package com.clx.performance.listener.child;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.clx.performance.common.MqWrapper;
import com.clx.performance.constant.RabbitKeyOrderChildConstants;
import com.clx.performance.service.OrderChildMqHandlerService;
import com.clx.performance.vo.mq.OrderChildAddMqParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @Author: 艾庆国
 * @Description: 运单新增 mq
 * @Date: 2023-10-20 16:34:40
 * @Version: 1.0
 */
@Slf4j
@Component
public class OrderChildAddListener {

    @Autowired
    private OrderChildMqHandlerService orderChildMqHandlerService;

    @RabbitListener(queues = RabbitKeyOrderChildConstants.ORDER_CHILD_ADD_QUEUE)
    public void process(Message message) {
        try{
            log.info("运单-新增, message:{}", new String(message.getBody()));
            process(JSON.parseObject(new String(message.getBody()), new TypeReference<MqWrapper<OrderChildAddMqParam>>(){}).getData());
        }catch (Exception e){
            log.info("运单-新增 失败",e);
        }
    }

    private void process(OrderChildAddMqParam mq){

        orderChildMqHandlerService.orderChildAdd(mq);

    }
}
